<!DOCTYPE html>
<html>
  <head>
    <title>Tạo đơn hàng - dành cho Admin</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body onload="onPageLoading()">
    <div class="container jumbotron py-4">
      <h1 class="text-center mb-5">Create Pizza Order - For Admin</h1>
      <div class="form-group row">
        <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-co-combo">
            <option value="NOT_SELECT_COMBO">
              Chọn cỡ Combo (Combo size)</option
            >
            <option value="S"> Nhỏ</option>
            <option value="M"> Vừa</option>
            <option value="L"> Lớn</option>
          </select>
        </div>
        <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-drink">
            <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Mã voucher</label>
        <div class="col-sm-4">
          <input
            type="text"
            class="form-control"
            id="input-ma-voucher"
            placeholder="Voucher ID (mã voucher)"
          />
        </div>
        <label class="col-sm-2 col-form-label">Loại pizza</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-loai-pizza">
            <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
            <option value="Seafood"> Hải sản</option>
            <option value="Hawaii"> Ha wai </option>
            <option value="Bacon"> Thịt hun khói </option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-4">
          <input
            type="text"
            class="form-control"
            id="input-ho-ten"
            placeholder="Họ và tên"
          />
        </div>
        <label for="" class="col-sm-2 col-form-label">Email</label>
        <div class="col-sm-4">
          <input
            type="email"
            class="form-control"
            id="input-email"
            placeholder="Email"
          />
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Số điện thoại</label>
        <div class="col-sm-4">
          <input
            type="text"
            class="form-control"
            id="input-sdt"
            placeholder="Số điện thoại"
          />
        </div>
        <label class="col-sm-2 col-form-label">Địa chỉ</label>
        <div class="col-sm-4">
          <input
            type="text"
            class="form-control"
            id="input-dia-chi"
            placeholder="Địa chỉ"
          />
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Lời nhắn</label>
        <div class="col-sm-10">
          <textarea
            class="form-control"
            id="textarea-loi-nhan"
            placeholder="Lời nhắn"
          ></textarea>
        </div>
      </div>
      <div class="form-group text-right">
        <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">
          Create Order
        </button>
      </div>
    </div>
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        // load dữ liệu vào select car
        loadDataDrinkList();
      }

      //hàm thực thi khi nút Create Order được nhấn
      function onBtnCreateOrderClick() {
        var vOrderObj = {
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          loaiPizza: "",
          idVoucher: "",
          idLoaiNuocUong: "",
          soLuongNuoc: "",
          hoTen: "",
          thanhTien: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: "",
        };

        //B1: đọc dữ liệu
        thuThapDuLieu(vOrderObj);
        //B2: kiểm tra dữ liệu
        var vCheck = kiemTraDuLieu(vOrderObj);
        if (vCheck) {
          //B3: Gọi api create order
          var vXmlHttpCreateOrder = new XMLHttpRequest();
          goiApiCreateOrder(vXmlHttpCreateOrder, vOrderObj);

          vXmlHttpCreateOrder.onreadystatechange = function () {
            if (
              this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              this.status == gREQUEST_CREATE_SUCCESS
            ) {
              // status 201 tao thanh cong
              var vCreatedOrder = vXmlHttpCreateOrder.responseText;
              console.log(vCreatedOrder);
              alert("Tạo đơn hàng thành công!");
              window.location.href = "indexListView.html";
            }
          };
        }
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // Hàm thực hiện call api để load dữ liệu vào drink list
      function loadDataDrinkList() {
        var vXhttp = new XMLHttpRequest();
        vXhttp.open(
          "GET",
          "http://203.171.20.210:8080/devcamp-pizza365/drinks",
          true
        );
        vXhttp.send();
        vXhttp.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
      }

      // handle data load to select drink
      function handleLoadDataToSelectDrink(paramXhttp) {
        var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
        console.log("array drink list = " + vArrayDrinkList.length);
        // load data to drink select
        var vElementSelectDrink = document.getElementById("select-drink");
        for (
          var bIterator = 0;
          bIterator < vArrayDrinkList.length;
          bIterator++
        ) {
          var bDrinkOptionElement = document.createElement("option");
          bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
          bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
          vElementSelectDrink.appendChild(bDrinkOptionElement);
        }
      }

      //hàm thu thập dữ liệu
      function thuThapDuLieu(paramOrderObj) {
        var vCoComboSelect = document.getElementById("select-co-combo");
        var vMaVoucherInput = document.getElementById("input-ma-voucher");
        var vHoTenInput = document.getElementById("input-ho-ten");
        var vSDTInput = document.getElementById("input-sdt");
        var vDrinkSelect = document.getElementById("select-drink");
        var vLoaiPizzaSelect = document.getElementById("select-loai-pizza");
        var vEmailInput = document.getElementById("input-email");
        var vDiaChiInput = document.getElementById("input-dia-chi");
        var vLoiNhanTextArea = document.getElementById("textarea-loi-nhan");

        paramOrderObj.kichCo = vCoComboSelect.value;
        paramOrderObj.idVoucher = vMaVoucherInput.value.trim();
        paramOrderObj.hoTen = vHoTenInput.value.trim();
        paramOrderObj.soDienThoai = vSDTInput.value.trim();
        paramOrderObj.idLoaiNuocUong = vDrinkSelect.value;
        paramOrderObj.loaiPizza = vLoaiPizzaSelect.value;
        paramOrderObj.email = vEmailInput.value.trim();
        paramOrderObj.diaChi = vDiaChiInput.value.trim();
        paramOrderObj.loiNhan = vLoiNhanTextArea.value.trim();

        //nếu người dùng chọn size S, M, L
        if (paramOrderObj.kichCo == "S") {
          paramOrderObj.duongKinh = 20;
          paramOrderObj.suon = 2;
          paramOrderObj.salad = 200;
          paramOrderObj.soLuongNuoc = 2;
          paramOrderObj.thanhTien = 150000;
        } else if (paramOrderObj.kichCo == "M") {
          paramOrderObj.duongKinh = 24;
          paramOrderObj.suon = 4;
          paramOrderObj.salad = 300;
          paramOrderObj.soLuongNuoc = 3;
          paramOrderObj.thanhTien = 200000;
        } else if (paramOrderObj.kichCo == "L") {
          paramOrderObj.duongKinh = 30;
          paramOrderObj.suon = 8;
          paramOrderObj.salad = 500;
          paramOrderObj.soLuongNuoc = 4;
          paramOrderObj.thanhTien = 250000;
        }
      }

      //hàm kiểm tra dữ liệu
      function kiemTraDuLieu(paramOrderObj) {
        if (paramOrderObj.kichCo == "NOT_SELECT_COMBO") {
          alert("Bạn cần chọn combo");
          return false;
        }

        if (paramOrderObj.idLoaiNuocUong == "NOT_SELECT_DRINK") {
          alert("Bạn cần chọn loại nước uống");
          return false;
        }

        if (paramOrderObj.loaiPizza == "NOT_SELECT_PIZZA") {
          alert("Bạn cần chọn loại pizza");
          return false;
        }

        if (paramOrderObj.hoTen == "") {
          alert("Bạn cần điền họ tên");
          return false;
        }

        if (paramOrderObj.soDienThoai == "") {
          alert("Bạn cần điền số điện thoại");
          return false;
        }

        if (paramOrderObj.diaChi == "") {
          alert("Bạn cần điền địa chỉ");
          return false;
        }

        if (validateEmail(paramOrderObj.email) == false) {
          alert("Email chưa đúng định dạng");
          return false;
        }

        return true;
      }

      // hàm kiểm tra email đúng định dạng ko?
      function validateEmail(paramEmail) {
        var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (paramEmail.match(vValidRegex)) {
          return true;
        } else {
          return false;
        }
      }

      //hàm gọi api create order
      function goiApiCreateOrder(paramXmlHttpCreateOrder, paramOrderObj) {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

        paramXmlHttpCreateOrder.open("POST", vBASE_URL, true);
        paramXmlHttpCreateOrder.setRequestHeader(
          "Content-Type",
          "application/json;charset=UTF-8"
        );
        paramXmlHttpCreateOrder.send(JSON.stringify(paramOrderObj));
      }
    </script>
  </body>
</html>
